#!/bin/python3
 # MAPIES base

from netCDF4 import Dataset, num2date, chartostring
from functools import wraps
from mapies.libs.func_tools import timeit
import time
import numpy as np
import xarray as xr




class MAPIES:
    """
    Base class for only base functions used in every Mapies run
    
    For example Reading and writing functions
    """
    def __init__(self):
        """
        INITIATE the MAPIES class with the variables used in every run
        """
        pass
        
    @timeit
    def determine_raw_file(self):
        """
        This method should be a method that determins the type of raw data and then calls the required raw file
        """
        if type(self.input_file) != str:
            raise "Input file not in str format check config"
        if self.input_file.endswith(".nc") or self.input_file.endswith(".nc4"):
            self.datatype = "nc" 
        elif self.input_file.endswith(".csv"):
            self.datatype = "csv"
        elif self.input_file.endswith(".h5") or self.inputfile.ends_with(".he5") or self.input_file.endswith(".hdf5"):
            self.datatype = "h5"
    
    @timeit
    def read_nc(self):
        """
        Read Netcdf files
        """
        self.f = Dataset(self.input_file, mode="a")
        
        # Get netcdf values and check whether they are what we would expect
        
        self.orig_dims = list(self.f.dimensions)
        if self.orig_dims != self.dims:
            print(f"Issue with dimensions of file: {self.input_file}")
            print(f"Different in dimensions is {set(self.orig_dims) - set(self.dims)}")
        #self.coords = list(ds.dimensions)
        self.orig_variables = list(self.f.variables)
        if self.orig_variables != self.variables:
            print(f"Issue with variables of file: {self.input_file}")
            print(f"Different in variables is {set(self.orig_variables) - set(self.variables)}")
            # I fear I am making this too complicated




    
    def read_csv(self):
        """
        Read CSV files
        """
        pass
    
    def read_h5(self):
        """
        Read HDF5 files
        """
        pass
    
    def to_da(self):
        """
        Base to da class
        
        # This can be origanised with Guillaume to acertain what type of input he now needs
        """
        pass
    
    def to_plumes(self):
        """
        Convert to format needed for the Plumes
        """
        pass
    
    def to_providentia(self):
        """
        Convert to format needed for Providentia
        """
        pass
    
    def to_xarray(self):
        """
        Converts the Array like structure that we will have to a xarray dataset if someone wants to work with MAPIES data in that way
        """
        x = 1
        
        
        
    def to_pandas(self):
        """
        Converts the Array like structure that we will have to a pandas dataframe if someone wants to work with MAPIES data in that way
        """
        pass
    
    def to_nessy(self):
        """
        Convert to a nes object to link with the NES project which is inbuilt in 
        """
        pass
    
    
    def change_variable_names(self):
        # Convert variable lon/lat/time to standardised name
        for old_name, new_name in self.renaming_dict.items():
            if new_name not in self.orig_variables:
                self.f.renameVariable(old_name, new_name)